MG = {}
MG.base = CreateFrame("Frame", nil, UIParent)
MG.inspectStage = 0
MG.myInventory = {}
MG.tick = 0
MG.playertick = 0
MG.targets = {}
MG.failover = 1
MG.history = {}
MG_DEBUGGING = true
MG.myRaid = false

function MG.eventhandler(self, event, ...)
	if (event == "GROUP_ROSTER_UPDATE" or event == "GROUP_JOINED") then MG.getPlayers() end
	if (event == "GROUP_JOINED") then MG.Options.Frame:Show() end
	if (event == "INSPECT_READY" and MG.inspectStage == 2) then MG.inspectStage = 3 end
	if (event == "CHAT_MSG_LOOT") then MG.lootRoutine({...}) MG.Lootframe_findFrame({...}) end
	if (event == "CHAT_MSG_RAID") then MG.getCommand({...}) end
	if (event == "ADDON_LOADED") then MG.init(...) end
	if (event == "PLAYER_LOGOUT") then MG.saveConfig() end
end

function MG.saveConfig() 
	for blubber = 1, #MG.history, 1 do
	tinsert(MGfullHistory, MG.history[blubber])
	end
	
end

function MG.init(...)
	local name = ...
	
	if (name == "MasterGypsy") then
		MGfullHistory = MGfullHistory or {}
		MG_NoDebug = MG_NoDebug or false
		MG_MyRaidSymbol = MG_MyRaidSymbol or "+"
		MG_WhisperText = MG_WhisperText or "Hey do you need (item)?"
		MG.Options.Frame.TEXT_RND:SetText(MG_WhisperText)
		MG.Options.Frame.TEXT_RAID:SetText(MG_MyRaidSymbol)
		
	end
end



function MG.getPlayers()
	MG.debug("Started MG.getplayers", 1)
	--local playerclass = nil
	local repeatcycle = false
	if (GetNumGroupMembers() == 0) then MG.targets = nil MG.targets = {} end
	for i = 1, GetNumGroupMembers(), 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
		--print(name)
		if (MG.getLootGroup(name) == nil) then repeatcycle = true end
		if (MG.getLootGroup(name) ~= nil) then MG.debug("  "..name.."->"..MG.getLootGroup(name),1 ) else MG.debug("  ".." no class",0) end
		if(MG.getLootGroup(name) == MG.myLootGroup) then MG.addPlayerToTargets(name) end
	end
	if (repeatcycle) then 
		MG.Viewport:SetScript("onUpdate", function(self, elapsed) 
			if (MG.playertick >= 1) then
				MG.getPlayers() 
				MG.playertick = 0
			else
				MG.playertick = MG.playertick + elapsed
			end
			
		end)
	else 
		MG.Viewport:SetScript("onUpdate", nil) 
		MG.debug("got all classes", 1) 
	end -- If a class wasn't identified, hook into onupdate and retry until resolved.
end

function MG.getLootGroup(character) -- prüft die Lootgruppe (cloth leather mail plate) des characters
	if (character ~= nil) then
		local foundClass = {UnitClass(character)}
		if (foundClass[2] == "WARLOCK") then return 1 end 
		if (foundClass[2] == "PRIEST") then return 1 end 
		if (foundClass[2] == "MAGE") then return 1 end 
		if (foundClass[2] == "DRUID") then return 2 end 
		if (foundClass[2] == "MONK") then return 2 end 
		if (foundClass[2] == "ROGUE") then return 2 end 
		if (foundClass[2] == "DEMONHUNTER") then return 2 end
		if (foundClass[2] == "SHAMAN") then return 3 end 
		if (foundClass[2] == "HUNTER") then return 3 end 
		if (foundClass[2] == "WARRIOR") then return 4 end 
		if (foundClass[2] == "PALADIN") then return 4 end 
		if (foundClass[2] == "DEATHKNIGHT") then return 4 end 
		return nil
	end
end

function MG.getInspectable(character)
	
	if (CanInspect(character) and CheckInteractDistance(character, 1)) then
		MG.debug("  Can inspect and interact")
		return true
	end
end

function MG.addPlayerToTargets(character)
	local checker = false
	for j = 1, #MG.targets, 1 do
		if (character == MG.targets[j].name) then 
		checker = true end
	end
	if (checker == false) then 
		local playerdetails = {}
		playerdetails.name = character
		playerdetails.class = UnitClass(character)
		playerdetails.lootGroup = MG.getLootGroup(character)
		playerdetails.isInspected = false
		playerdetails.inventory = {}
		tinsert(MG.targets, playerdetails)
	end
end

function MG.getCommand(args)
	if(args[1] == MG_MyRaidSymbol and MG.myRaid == true) then
		item = MG.getLastItem(args[5])
		if (isTargetOrUseful(args[5],item) and args[5] ~= UnitName("player")) then MG.createLootframe(args[5], item) end
	end
end

function MG.Lootframe_findFrame(msg)
	local filter = MG.chatGetLootedItem(msg[1])
	if (MG.myRaid) then

		for p = 1, #MG.Viewport.Lootframes, 1 do
			if (MG.Viewport.Lootframes[p].item == filter) then
				for p2= 1, #MG.Viewport.Lootframes, 1 do MG.Lootframe_StopHighlight(MG.Viewport.Lootframes[p2]) end
				MG.Lootframe_StartHighlight(MG.Viewport.Lootframes[p])
			end
		end	
	end
end

function isTargetOrUseful(target, item)
	for mx = 1, #MG.targets, 1 do
		if MG.targets[mx].name == target then return true end
	end
	local is = MG.getItemSlot(item)
	if (is == "artifact" or is == "trinket" or is == "finger" or is == "neck") then return true end
	return false
end

function MG.getLastItem(looter)
	for finlas = #MG.history, 1, -1 do
		if (MG.history[finlas].name == looter and MG.history[finlas].bonus == false) then
			return MG.history[finlas].item
		end
	end
end

function MG.lootRoutine(args)
	local looter = args[5]
	--print(looter)
	local lootedItem = MG.chatGetLootedItem(args[1])
	local qual_tmp = {GetItemInfo(lootedItem)}
	local bonusroll = string.find(args[1], "bonus")
	if (qual_tmp[3] >= 4) then MG.createHistoryEntry(args[5], lootedItem, bonusroll) end
	
	if (looter ~= UnitName("player")) then 
	local useful = MG.compare_items(looter, lootedItem, bonusroll)
		if(useful and MG.myRaid == false) then
			MG.createLootframe(looter, lootedItem)
		end
	end
end

function MG.createLootframe(looter, lootedItem)
	MG.Viewport:Show()
	framefinder = 1
	while(framefinder <=7 and MG.Viewport.Lootframes[framefinder].isUsed == true) do
		framefinder = framefinder + 1
	end
	if (framefinder <= 7) then -- hier kann später eine queue rein, habe da nur gerade keine lust drauf...
		local lf = MG.Viewport.Lootframes[framefinder]
		lf.isUsed = true
		lf.looter = looter
		lf.item = lootedItem
		lf.item_table = {GetItemInfo(lf.item)}
		lf.itemlink = lf.item_table[2]
		lf.Text:SetText(looter .. " looted " .. MG.getItemSlot(lf.item) .." (" ..lf.item_table[4]..")")
		lf.itemframe.bg:SetTexture(lf.item_table[10])
		--print("in creator:" .. lf.itemlink)
		if (MG.myRaid) then lf.button_roll:SetText("Roll") else lf.button_roll:SetText("Whisper") end
		MG.Viewport.Lootframes[framefinder] = lf
		MG.Viewport.Lootframes[framefinder]:Show()
	end
	
end

function MG.closeFrame(frame)
	frame.isUsed = false
	frame:Hide()
	local checkHide = true
	for x = 1, 7, 1 do
		if (MG.Viewport.Lootframes[x].isUsed) then checkHide = false end
	end
	if (checkHide) then MG.Viewport:Hide() end
end

function MG.compare_items(looter, lootedItem)
	local tmp = {GetItemInfo(lootedItem)}
	--print("comparing...")
	if (MG.getItemSlot(lootedItem) ~= 99) then
		if (MG.getItemSlot(lootedItem) == "artifact") then return true end
		if (tmp[3]==4 and bonusroll == nil) then
			local ilvl_looted = tmp[4]
			local tmp_worn = nil
			local tmp_worn_ilvl = 9000
			for sr = 1, #MG.targets, 1 do
				if (MG.targets[sr].name ==looter) then
					if (MG.getItemSlot(lootedItem) == "finger" or MG.getItemSlot(lootedItem) == "trinket") then
						if (MG.getItemSlot(lootedItem) == "finger") then
							local f1 = {GetItemInfo(MG.targets[sr].inventory["finger1"])}
							local f2 = {GetItemInfo(MG.targets[sr].inventory["finger2"])}
							if f2[4] >f1[4] then tmp_worn_ilvl = f2[4] else tmp_worn_ilvl = f1[4] end
						end
						if (MG.getItemSlot(lootedItem) == "trinket") then
							local f1 = {GetItemInfo(MG.targets[sr].inventory["trinket1"])}
							local f2 = {GetItemInfo(MG.targets[sr].inventory["trinket2"])}
							if f2[4] >f1[4] then tmp_worn_ilvl = f2[4] else tmp_worn_ilvl = f1[4] end
						end
					else
						tmp_worn = {GetItemInfo(MG.targets[sr].inventory[MG.getItemSlot(lootedItem)])}
						tmp_worn_ilvl = tmp_worn[4]
					end
				end
			end
			local MyWorn = nil
			local myworn_ilvl = nil
			
			if (MG.getItemSlot(lootedItem) == "finger" or MG.getItemSlot(lootedItem) == "trinket") then
				if (MG.getItemSlot(lootedItem) == "finger") then
					local f1 = {GetItemInfo(MG.myInventory["finger1"])}
					local f2 = {GetItemInfo(MG.myInventory["finger2"])}
						if f2[4] <f1[4] then myworn_ilvl = f2[4] else myworn_ilvl = f1[4] end
				end
				if (MG.getItemSlot(lootedItem) == "trinket") then
					local f1 = {GetItemInfo(MG.targets[sr].inventory["trinket1"])}
					local f2 = {GetItemInfo(MG.targets[sr].inventory["trinket2"])}
					if f2[4] < f1[4] then myworn_ilvl = f2[4] else myworn_ilvl = f1[4] end
				end
				else
					myWorn = {GetItemInfo(MG.myInventory[MG.getItemSlot(lootedItem)])}
					myworn_ilvl = myWorn[4]
			end
			--print (myworn_ilvl .. " " .. ilvl_looted .. " " .. tmp_worn_ilvl)
			
			--myWorn = {GetItemInfo(MG.myInventory[MG.getItemSlot(lootedItem)])}
			--myworn_ilvl = myWorn[4]
			
			if ((myworn_ilvl <= ilvl_looted and ilvl_looted <=tmp_worn_ilvl)) then
				--print("true")
				return true --yay
			else
				--print("false")
				return false -- item sucks
			end
		else 
			return false -- item is not epic or bonusroll
		end
	else 
		return false -- item is 99, so not identifiable
	end
	
end
	
function MG.getItemSlot(item)
	local a = {GetItemInfo(item)}
	if (a[9] == "INVTYPE_HEAD") then return "head" end
	if (a[9] == "INVTYPE_NECK") then return "neck"  end
	if (a[9] == "INVTYPE_SHOULDER") then return "shoulder" end
	if (a[9] == "INVTYPE_CHEST") then return "chest" end
	if (a[9] == "INVTYPE_ROBE") then return "chest" end
	if (a[9] == "INVTYPE_WAIST") then return "waist" end
	if (a[9] == "INVTYPE_LEGS") then return "legs" end
	if (a[9] == "INVTYPE_FEET") then return "feet" end
	if (a[9] == "INVTYPE_WRIST") then return "wrist" end
	if (a[9] == "INVTYPE_HAND") then return "hands" end
	if (a[9] == "INVTYPE_FINGER") then return "finger" end
	--if (a[9] == "INVTYPE_FINGER") then return 12 end
	if (a[9] == "INVTYPE_TRINKET") then return "trinket" end
	--if (a[9] == "INVTYPE_FINGER") then return 14 end
	if (a[9] == "INVTYPE_BACK") then return "back" end
	if (a[7] == "Artifact Relic") then return "artifact" end
	return 99
	
end

function MG.chatGetLootedItem(message) -- return ItemInfo des Gegenstands als table
	--MG.debug("Started: chatGetLootedItem",1)
	local itemname_start = string.find(message, "|") 
	local itemname_end = string.find(message, "|h|r")+3
	--MG.debug(string.sub(message, itemname_start, itemname_end), 1)
	local itemInfo = string.sub(message, itemname_start, itemname_end)
	--MG.debug("Finished: chatGetLootedItem", 1)
	return itemInfo
end

function MG.inspectPlayers(self, elapsed)
	--if (MG_DEBUGGING == false) then MG.debuglog = nil MG.debuglog = {} end
	if (MG.tick == 0) then
		--MG.debug ("CurStage: " ..MG.inspectStage)
		if (MG.inspectStage == 0) then
			--MG.debug("InspectStage: 0",1)
			--MG.debug("  Checking targets",1)
			for m = 1, #MG.targets, 1 do
				if (MG.targets[m].isInspected == false and MG.getInspectable(MG.targets[m].name) and MG.inspectStage ==0) then 
					MG.debug("  target inspectable",1)
					MG.curInspectTarget = MG.targets[m].name
					MG.curInspectTargetId = m
					MG.inspectStage = 1
				end
			end
		end
		
		if (MG.inspectStage == 1 and MG.getInspectable(MG.curInspectTarget)) then
			MG.debug("InspectStage: 1",1)
			NotifyInspect(MG.curInspectTarget)
			MG.inspectStage = 2
		end
		
		if (MG.inspectStage == 2) then
			MG.failover = MG.failover + 1
			if (MG.failover == 5) then
				MG.failover = 1
				ClearInspectPlayer()
				MG.inspectStage = 1
			end
		end
		
		if (MG.inspectStage == 3) then 
			MG.debug("InspectStage: 3",1)
			local checkedEverything = true
			local inventory = {}
			if(GetInventoryItemLink(MG.curInspectTarget, 1) == nil) then checkedEverything = false else inventory.head = GetInventoryItemLink(MG.curInspectTarget, 1) end
			if(GetInventoryItemLink(MG.curInspectTarget, 2) == nil) then checkedEverything = false else inventory.neck = GetInventoryItemLink(MG.curInspectTarget, 2) end
			if(GetInventoryItemLink(MG.curInspectTarget, 3) == nil) then checkedEverything = false else inventory.shoulder = GetInventoryItemLink(MG.curInspectTarget, 3) end
			if(GetInventoryItemLink(MG.curInspectTarget, 5) == nil) then checkedEverything = false else inventory.chest = GetInventoryItemLink(MG.curInspectTarget, 5) end
			if(GetInventoryItemLink(MG.curInspectTarget, 6) == nil) then checkedEverything = false else inventory.waist = GetInventoryItemLink(MG.curInspectTarget, 6) end
			if(GetInventoryItemLink(MG.curInspectTarget, 7) == nil) then checkedEverything = false else inventory.legs = GetInventoryItemLink(MG.curInspectTarget, 7) end
			if(GetInventoryItemLink(MG.curInspectTarget, 8) == nil) then checkedEverything = false else inventory.feet = GetInventoryItemLink(MG.curInspectTarget, 8) end
			if(GetInventoryItemLink(MG.curInspectTarget, 9) == nil) then checkedEverything = false else inventory.wrist = GetInventoryItemLink(MG.curInspectTarget, 9) end
			if(GetInventoryItemLink(MG.curInspectTarget, 10) == nil) then checkedEverything = false else inventory.hands = GetInventoryItemLink(MG.curInspectTarget, 10) end
			if(GetInventoryItemLink(MG.curInspectTarget, 11) == nil) then checkedEverything = false else inventory.finger1 = GetInventoryItemLink(MG.curInspectTarget, 11) end
			if(GetInventoryItemLink(MG.curInspectTarget, 12) == nil) then checkedEverything = false else inventory.finger2 = GetInventoryItemLink(MG.curInspectTarget, 12) end
			if(GetInventoryItemLink(MG.curInspectTarget, 13) == nil) then checkedEverything = false else inventory.trinket1 = GetInventoryItemLink(MG.curInspectTarget, 13) end
			if(GetInventoryItemLink(MG.curInspectTarget, 14) == nil) then checkedEverything = false else inventory.trinket2 = GetInventoryItemLink(MG.curInspectTarget, 14) end
			if(GetInventoryItemLink(MG.curInspectTarget, 15) == nil) then checkedEverything = false else inventory.back = GetInventoryItemLink(MG.curInspectTarget, 15) end
			if (checkedEverything) then
				for xll = 1, #MG.targets, 1 do 
					if (MG.targets[xll].name == MG.curInspectTarget) then
						MG.targets[xll].inventory = inventory
						MG.targets[xll].isInspected = true
						MG.inspectStage = 0
						MG.curInspectTarget = nil
						MG.curInspectTargetId = nil
						ClearInspectPlayer()
					end
				end
			end
			MG.debug("Inventory filled",1)
		end
	end
	
	
	MG.tick = MG.tick + elapsed
	if (MG.tick > 1) then MG.tick = 0 end
end

function MG.getMyEquipment()
		local inventory = {}
		local checkedEverything = true
		if(GetInventoryItemLink(UnitName("player"), 1) == nil) then checkedEverything = false else inventory.head = GetInventoryItemLink(UnitName("player"), 1) end
		if(GetInventoryItemLink(UnitName("player"), 2) == nil) then checkedEverything = false else inventory.neck = GetInventoryItemLink(UnitName("player"), 2) end
		if(GetInventoryItemLink(UnitName("player"), 3) == nil) then checkedEverything = false else inventory.shoulder = GetInventoryItemLink(UnitName("player"), 3) end
		if(GetInventoryItemLink(UnitName("player"), 5) == nil) then checkedEverything = false else inventory.chest = GetInventoryItemLink(UnitName("player"), 5) end
		if(GetInventoryItemLink(UnitName("player"), 6) == nil) then checkedEverything = false else inventory.waist = GetInventoryItemLink(UnitName("player"), 6) end
		if(GetInventoryItemLink(UnitName("player"), 7) == nil) then checkedEverything = false else inventory.legs = GetInventoryItemLink(UnitName("player"), 7) end
		if(GetInventoryItemLink(UnitName("player"), 8) == nil) then checkedEverything = false else inventory.feet = GetInventoryItemLink(UnitName("player"), 8) end
		if(GetInventoryItemLink(UnitName("player"), 9) == nil) then checkedEverything = false else inventory.wrist = GetInventoryItemLink(UnitName("player"), 9) end
		if(GetInventoryItemLink(UnitName("player"), 10) == nil) then checkedEverything = false else inventory.hands = GetInventoryItemLink(UnitName("player"), 10) end
		if(GetInventoryItemLink(UnitName("player"), 11) == nil) then checkedEverything = false else inventory.finger1 = GetInventoryItemLink(UnitName("player"), 11) end
		if(GetInventoryItemLink(UnitName("player"), 12) == nil) then checkedEverything = false else inventory.finger2 = GetInventoryItemLink(UnitName("player"), 12) end
		if(GetInventoryItemLink(UnitName("player"), 13) == nil) then checkedEverything = false else inventory.trinket1 = GetInventoryItemLink(UnitName("player"), 13) end
		if(GetInventoryItemLink(UnitName("player"), 14) == nil) then checkedEverything = false else inventory.trinket2 = GetInventoryItemLink(UnitName("player"), 14) end
		if(GetInventoryItemLink(UnitName("player"), 15) == nil) then checkedEverything = false else inventory.back = GetInventoryItemLink(UnitName("player"), 15) end
		if (checkedEverything) then
			MG.myInventory = inventory
		end
		return checkedEverything
end

function MG.createHistoryEntry(looter, lootedItem, bonusroll)
	--print(lootedItem)
	local tmp = {GetItemInfo(lootedItem)}
	local quality = tmp[3]
	if (quality >= 4) then 
		local newEntry = {}
		local mgdatestamp = {CalendarGetDate()}	
		local mgtimestamp = {GetGameTime()}
		
		newEntry.name = looter
		newEntry.class = UnitClass(looter)
		newEntry.date  = {mgdatestamp[4], mgdatestamp[3], mgdatestamp[2]} -- year month day
		newEntry.time = {mgtimestamp[1], mgtimestamp[2]} -- hour -- minute
		newEntry.zone = GetRealZoneText()
		newEntry.zoneID = nil
		local gb = {GetInstanceInfo}
		if gb[2] == "none" then newEntry.zone = "Open World" end
		if gb[2] ~= "none" then newEntry.zoneID = gb[8] end
		newEntry.item = lootedItem
		if (bonusroll ~= nil) then newEntry.bonus = true else newEntry.bonus = false end
		tinsert(MG.history, newEntry)
	end
	--return newEntry
end

function MG.initViewport()
	MG.Viewport = CreateFrame("Frame", "MasterGypsy", UIParent)
	
	MG.Viewport:SetSize(230, 420)
	MG.Viewport:SetPoint("Center", UIParent, -300, 0)
	MG.Viewport:SetMovable(true)
	
	MG.Viewport.Header = CreateFrame("Frame", nil, MG.Viewport)
	MG.Viewport.Header:SetSize(230, 30)
	MG.Viewport.Header:SetPoint("TOPLEFT", 0,0)
	MG.Viewport.Header:SetBackdrop({bgFile="Interface/AddOns/MasterGypsy/textures/white.tga", edgeFile="Interface/AddOns/MasterGypsy/textures/black.tga", tile=true, tileSize=32, edgeSize=2, insets={left =0, right = 0, top = 0, bottom =0}})
	MG.Viewport.Header:SetBackdropColor(.1,.1,.1,1)
	MG.Viewport.Header:EnableMouse(true)
	
	MG.Viewport.Header:RegisterForDrag("LeftButton")
	MG.Viewport.Header:SetScript("OnDragStart", function(self, button, ...) self:GetParent():StartMoving() end)
	MG.Viewport.Header:SetScript("OnDragStop", function(self, button, ...) self:GetParent():StopMovingOrSizing() end)
	MG.Viewport.Header.Text = MG.Viewport.Header:CreateFontString(nil,"ARTWORK", "GameFontNormal")
	MG.Viewport.Header.Text:SetSize(MG.Viewport.Header:GetSize())
	MG.Viewport.Header.Text:SetPoint("CENTER")
	MG.Viewport.Header.Text:SetText("You might be interested in this ...")
	
	MG.Viewport.Lootframes={}
	--/run MG.Viewport.Lootframes[1].item = ""
	for i = 0, 6, 1 do
		local tmp = CreateFrame("Frame", nil, MG.Viewport)
		tmp.isUsed = false
		tmp.item = nil
		tmp.item_table = nil
		tmp.itemlink = nil
		tmp.looter = nil
		
		tmp:SetSize(230,60)
		tmp:SetPoint("Topleft", 0, -(30 + (i * 60)))
		tmp:SetBackdrop({bgFile="Interface/AddOns/MasterGypsy/textures/white.tga", edgeFile="Interface/AddOns/MasterGypsy/textures/black.tga", tile=true, tileSize=32, edgeSize=2, insets={left =0, right = 0, top = 0, bottom =0}})
		--tmp:SetBackdropColor(1/(i+1),1/(i+1),1/(i+1),1/(i+1))
		tmp:SetBackdropColor(.1,.1,.1,1)
		
		tmp.border = CreateFrame("Frame", nil, tmp)
		tmp.border:SetSize(tmp:GetSize())
		tmp.border:SetPoint("TOPLEFT")
		tmp.border:SetBackdrop({bgFile=nil, edgeFile="Interface/AddOns/MasterGypsy/textures/white.tga", tile=true, tileSize=32, edgeSize=2, insets={left =0, right = 0, top = 0, bottom =0}})
		tmp.border:SetBackdropBorderColor(1,1,0,0)
		tmp.border.tex = tmp.border:CreateTexture(nil, "ARTWORK")
		tmp.border.tex:SetTexture([[Interface\SpellActivationOverlay\IconAlert]])
		tmp.border.tex:SetTexCoord(0.00781250, 0.50781250, 0.27734375, 0.52734375)
		tmp.border.tex:SetPoint("TOPLEFT", -85, 20)
		tmp.border.tex:SetSize(400,100)
		tmp.border:SetAlpha(0)
		
		tmp.Text = tmp:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		tmp.Text:SetText("Looter: <insertusername>")
		tmp.Text:SetPoint("Topleft", 5+50+5+5  , -10)
		
		tmp.itemframe = CreateFrame("Frame", nil, tmp)
		tmp.itemframe:SetSize(50, 50)
		tmp.itemframe:SetPoint("TOPLEFT", 5, -5)
		--tmp.itemframe.bg = "a"
		--print(tmp.itemframe.bg)
		tmp.itemframe.bg = tmp.itemframe:CreateTexture(nil, "ARTWORK", tmp.itemframe)
		tmp.itemframe.bg:SetSize(50,50)
		tmp.itemframe.bg:SetPoint("TOPLEFT")
		tmp.itemframe.bg:SetTexture(1549274)
		tmp.button_roll = CreateFrame("Button", nil, tmp, "UIPanelButtonTemplate")
		tmp.button_roll:SetSize(80, 25)
		tmp.button_roll.Text:SetText("Get it")
		tmp.button_roll:SetPoint("BOTTOMLEFT", 5+50+5, 5)
		tmp.button_roll:SetScript("onClick", function(self) 
			if (MG.myRaid) then 
				RandomRoll(1,100)
			else
				local whispertarget = self:GetParent().looter
				local basestring = MG_WhisperText
				local whisperString = string.sub(basestring, 1, string.find(basestring, "(item)")-2) .. self:GetParent().itemlink .. string.sub(basestring, string.find(basestring, "(item)")+5)
				SendChatMessage(whisperString, "WHISPER", nil, whispertarget)
			end
			self:GetParent().isUsed = false
			MG.closeFrame(self:GetParent())
		end)
	
		tmp.button_pass = CreateFrame("Button", nil, tmp, "UIPanelButtonTemplate")
		tmp.button_pass:SetSize(80, 25)
		tmp.button_pass.Text:SetText("Pass")
		tmp.button_pass:SetPoint("BOTTOMLEFT", 5+50+5+5+80, 5)
		tmp.button_pass:SetScript("onClick", function(self) 
			MG.closeFrame(self:GetParent())
		end)
		tmp.showItem = function(self)
			local bsg = {GetItemInfo(self:GetParent().item)}
			ShowUIPanel(GameTooltip)
			GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
			GameTooltip:SetHyperlink(bsg[2])
			GameTooltip:Show()
		end
		
		tmp.hideItem = function(self)
			GameTooltip:Hide()
		end
		
		tmp.itemframe:SetScript("onEnter", tmp.showItem)
		tmp.itemframe:SetScript("onLeave", tmp.hideItem)
		
		tmp:Hide()
		
		tinsert(MG.Viewport.Lootframes, tmp)
	end
	
end

function MG.Lootframe_StartHighlight(frame)
	frame.border:SetBackdropBorderColor(1,1,0,1)
	frame.border:SetAlpha(1)
end
function MG.Lootframe_StopHighlight(frame)
	frame.border:SetBackdropBorderColor(1,1,0,0)
	frame.border:SetAlpha(0)
	
end
	
--Debug Appendix
function MG.initDebugWindow()
	MG.debuglog = {}
	MG.debuglog.log = {}
	MG.debuglog.index = 1
	MG.debuglog.refresh = true
	MG.debuglog.frameset = {}
	MG.debuglog.frameset.mainframe = CreateFrame("Frame", "MGDebugFrame", UIParent, "UIPanelDialogTemplate")
	MG.debuglog.frameset.mainframe.logframes = {}
	MG.debuglog.frameset.mainframe.Title:SetText("Use Scrollwheel...")
	MG.debuglog.frameset.mainframe:SetPoint("Center", 500, 0)
	MG.debuglog.frameset.mainframe:SetSize(211, 135)
	MG.debuglog.frameset.mainframe.pause = CreateFrame("Button", nil, MG.debuglog.frameset.mainframe, "UIPanelButtonTemplate")
	MG.debuglog.frameset.mainframe.pause:SetPoint("BOTTOMLEFT", MG.debuglog.frameset.mainframe, 5, -10)
	MG.debuglog.frameset.mainframe.pause:SetSize(200, 20)
	MG.debuglog.frameset.mainframe.pause:SetText("AutoUpdate ON")
	MG.debuglog.frameset.mainframe.pause:SetScript("onClick", function() if (MG.debuglog.refresh) then MG.debuglog.refresh = false MG.debuglog.frameset.mainframe.pause:SetText("AutoUpdate OFF") else MG.debuglog.refresh = true MG.debuglog.frameset.mainframe.pause:SetText("AutoUpdate ON") end end)
	
	for i = 1, 5, 1 do 
		local newframe = CreateFrame("Frame", "logframe"..i, MG.debuglog.frameset.mainframe, "TooltipBorderedFrameTemplate")
		newframe:SetPoint("TOPLEFT",MG.debuglog.frameset.mainframe, 7, -(25 + ((i-1)*20)))
		newframe:SetSize(200, 25)
		newframe.Text = newframe:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		newframe.Text:SetPoint("left", newframe, 10, 0)
		newframe.Text:SetSize(200, 25)
		newframe.Text:SetJustifyH("LEFT")
		newframe:SetFrameLevel(MG.debuglog.frameset.mainframe:GetFrameLevel()+1)
		tinsert(MG.debuglog.frameset.mainframe.logframes, newframe)
		
		
		
	end
	tinsert(MG.debuglog.log, {"Starting...", 1})
	MG.debuglog.frameset.mainframe:SetScript("OnMouseWheel", function(self, delta) 
		if (delta == -1 and (MG.debuglog.index <= #MG.debuglog.log - 5)) then  
			MG.debuglog.index = MG.debuglog.index + 1
		end
		if (delta == 1 and (MG.debuglog.index  > 1)) then  
			MG.debuglog.index = MG.debuglog.index -1
		end
		for i = 1, 5, 1 do
			
			if (i+MG.debuglog.index -1 <= #MG.debuglog.log and i+MG.debuglog.index-1 >=1) then
				MG.debuglog.frameset.mainframe.logframes[i].Text:SetText(MG.debuglog.log[i+MG.debuglog.index-1][1])
				if MG.debuglog.log[i+MG.debuglog.index-1][2] == 1 then
					MG.debuglog.frameset.mainframe.logframes[i].Text:SetTextColor(0,1,0,1)
				else
					MG.debuglog.frameset.mainframe.logframes[i].Text:SetTextColor(1,0,0,1)
				end
			end
		end
	end)
	MG.debuglog.frameset.mainframe:Hide()
	--/run MG.debuglog.frameset.mainframe.logframes[1]:SetFrameLevel(MG.debuglog.frameset.mainframe:GetFrameLevel() + 1)
		
end

function MG.debugger() MG.debuglog.frameset.mainframe:Show() end

function MG.debug(text, success) -- string | bool
	if (MG_DEBUGGING) then
		tinsert(MG.debuglog.log, {text, success})
		if MG.debuglog.refresh then
			--print("OK")
			for i = 1, 5, 1 do
				if (#MG.debuglog.log - 5 + i >= 1 and #MG.debuglog.log - 5 + i <= #MG.debuglog.log) then
				--print("should have printed")
				
				MG.debuglog.frameset.mainframe.logframes[i].Text:SetText(MG.debuglog.log[#MG.debuglog.log - 5 + i][1])
				
				if MG.debuglog.log[(#MG.debuglog.log-5) + i][2] == 1 then
						MG.debuglog.frameset.mainframe.logframes[i].Text:SetTextColor(0,1,0,1)
					else
						MG.debuglog.frameset.mainframe.logframes[i].Text:SetTextColor(1,0,0,1)
					end
				
				--MG.debuglog.frameset.mainframe.logframes[i].Text:SetText(MG.debuglog.log[(#MG.debuglog.log-5) + i][1])
				--MG.debuglog.frameset.mainframe.logframes[i].Text:SetTextColor(MG.debuglog.log[(#MG.debuglog.log-5) + i][2])
				end
			end
			MG.debuglog.index = #MG.debuglog.log - 4
		end
	end
end

function MG.initHistoryFrame()
	MG.HistoryFrame = {}
	MG.HistorySections = MG.CreateHistorySections()
	--local MG_HF = MG.HistoryFrame
	MG.HistoryFrame.SelectorFrame = CreateFrame("Frame", nil, UIParent)
	--local MG_HF_SF = MG.HF.SelectorFrame
	MG.HistoryFrame.SelectorFrame:SetSize(800, 600)
	MG.HistoryFrame.SelectorFrame:SetPoint("CENTER")
	MG.HistoryFrame.SelectorFrame.Texture = MG.HistoryFrame.SelectorFrame:CreateTexture(nil, "ARTWORK")
	MG.HistoryFrame.SelectorFrame.Texture:SetTexture(904010)
	MG.HistoryFrame.SelectorFrame.Texture:SetTexCoord(0.285,.55,0,0.455)
	MG.HistoryFrame.SelectorFrame.Texture:SetSize(MG.HistoryFrame.SelectorFrame.Texture:GetParent():GetSize())
	MG.HistoryFrame.SelectorFrame.Texture:SetPoint("Center")
	MG.HistoryFrame.SelectorFrame.Panels = {}
	
	local rows = math.floor(#MG.HistorySections/3)
		if (rows > 3) then rows = 3 end
	
	for i = 1, rows, 1 do
		for j = 1, (MG.HistorySections%Rows), 1 do
			local tmp = CreateFrame("Frame", nil, MG.HistoryFrame.SelectorFrame)
			tmp:SetSize(200, 150)
			tmp:SetPoint("TOPLEFT", (j*50) + ((j-1)*200), -((i*50)+((i-1)*150)))
			tmp.Title = tmp:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
			tmp.Title:SetText("Antorian Waste")
			tmp.Title:SetSize(tmp:GetSize())
			tmp.Title:SetPoint("Bottomleft", 5, -10)
			tmp.Title:SetJustifyH("CENTER")
			tmp.Title:SetJustifyV("CENTER")
			tmp.Date = tmp:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
			tmp.Date:SetText("2017.12.07")
			tmp.Date:SetSize(tmp:GetSize())
			tmp.Date:SetPoint("Bottomleft", 5, -30)
			tmp.Date:SetJustifyH("CENTER")
			tmp.Date:SetJustifyV("CENTER")

			tmp.Texture = tmp:CreateTexture(nil,"ARTWORK")
			tmp.Texture:SetTexture(1718203)
			tmp.Texture:SetSize(280,200)
			tmp.Texture:SetPoint("Topleft")
			tinsert(MG.HistoryFrame.SelectorFrame.Panels, tmp)
		end
	end
			--MG.HistoryFrame.SelectorFrame.Panels
end

--MG.getZone(history)

function MG.CreateHistorySections()
	local HistorySections = {}
	local curZone = nil
	local curSection = {}
	if (#MG.history > 0 or #MGfullHistory > 0) then

		curSection.loot = {}
		if (#MG.history>0) then
			print ("history > 0 #1")
			if (MG.history[#MG.history].zone~=nil) then curZone = MG.history[#MG.history].zone else curZone ="Open World" end
		else
			if (MGfullHistory[#MGfullHistory].zone ~= nil) then curZone = MGfullHistory[#MGfullHistory].zone else curZone = "Open World" end
		end
		
		if (#MG.history > 0) then	
			print ("history > 0 #2")
			for i = #MG.history, 1, -1 do
				if (MG.history[i].zone == nil) then MG.history[i].zone = "Open World" end
				print(MG.history[i].zone)
				if (MG.history[i].zone == curZone) then
					tinsert(curSection.loot, MG.history[i])
					print(i)
					if (i == 1) then tinsert(HistorySections, curSection) print("worked") end
				else
					curSection.name = curZone
					curSection.start = curSection.loot[#curSection.loot].date[1].."."..curSection.loot[#curSection.loot].date[2].."."..curSection.loot[#curSection.loot].date[3].." ".. curSection.loot[#curSection.loot].time[1] ..":"..curSection.loot[#curSection.loot].time[2]
					tinsert(HistorySections, curSection)
					curSection = nil
					curSection = {}
					curZone = MG.history[i].zone
					tinsert(curSection, MG.history[i])
					if (i == 1) then tinsert(HistorySections, curSection) print("worked")  end
				end
			end
		end --mghistory end
		
		if (#MGfullHistory > 0) then	
			for i = #MGfullHistory, 1, -1 do
				if (MGfullHistory[i].zone == nil) then MGfullHistory[i].zone = "Open World" end
				if (MGfullHistory[i].zone == curZone) then
					tinsert(curSection, MGfullHistory[i])
					if (i == 1) then tinsert(HistorySections, curSection) print("worked")  end
				else
					curSection.name = curZone
					curSection.start = "01.01.2000 17:22" --curSection.loot[#curSection.loot].date[1].."."..curSection.loot[#curSection.loot].date[2].."."..curSection.loot[#curSection.loot].date[3].." ".. curSection.loot[#curSection.loot].time[1] ..":"..curSection.loot[#curSection.loot].time[2]
					curSection.zoneID =
					tinsert(HistorySections, curSection)
					curSection = nil
					curSection = {}
					curZone = MGfullHistory[i].zone
					tinsert(curSection, MGfullHistory[i])
					if (i == 1) then tinsert(HistorySections, curSection) print("worked")  end
				end
			end
		end --fullhistory end
	end
	print(#HistorySections)
	return HistorySections
end



function MG.initOptions()
	MG.Options = {}
	MG.Options.Frame = CreateFrame("Frame", nil, UIParent, "BasicFrameTemplateWithInset")
	MG.Options.Frame.TitleText:SetText("Master Gypsy Options")
	MG.Options.Frame:SetSize(400, 100)
	MG.Options.Frame:SetPoint("Center")
	local c_x = 10
	local c_y = 30
	MG.Options.Frame.CB_RND = CreateFrame("CheckButton", nil, MG.Options.Frame, "UICheckButtonTemplate")
	MG.Options.Frame.CB_RND:SetPoint("TOPLEFT", c_x, -c_y)
	MG.Options.Frame.CB_RND.text:SetText("Random Group/Raid")
	MG.Options.Frame.CB_RND:SetChecked(true)
	MG.Options.Frame.CB_RND:SetScript("onClick", function(self) self:SetChecked(true) MG.Options.Frame.CB_RAID:SetChecked(false) MG.Options.Frame.TEXT_RND:Disable() MG.Options.Frame.TEXT_RAID:Disable() end)
	c_x = c_x + MG.Options.Frame.CB_RND:GetWidth() + MG.Options.Frame.CB_RND.text:GetWidth() + 10
	MG.Options.Frame.TEXT_RND  = CreateFrame("EditBox", nil, MG.Options.Frame, "InputBoxTemplate")
	MG.Options.Frame.TEXT_RND:SetPoint("Topleft", c_x, -(c_y+5))
	MG.Options.Frame.TEXT_RND:SetSize(200, 20)
	MG.Options.Frame.TEXT_RND:SetText(MG_WhisperText or "Hey do you need (item)?")
	MG.Options.Frame.TEXT_RND:Disable()
	MG.Options.Frame.TEXT_RND:SetScript("onMouseUp", function(self) 
		MG.Options.Frame.TEXT_RAID:Disable()
		MG.Options.Frame.TEXT_RAID:HighlightText(0,0)
		MG.Options.Frame.CB_RAID:SetChecked(false)
		MG.Options.Frame.CB_RND:SetChecked(true)
		self:Enable() 
		self:HighlightText() end)
	MG.Options.Frame.TEXT_RND:SetScript("onKeyDown", function(self, key) if(key=="ENTER") then self:Disable() end end)
	
	
	c_y = 30 + 30
	c_x = 10
	
	MG.Options.Frame.CB_RAID = CreateFrame("CheckButton", nil, MG.Options.Frame, "UICheckButtonTemplate")
	MG.Options.Frame.CB_RAID:SetPoint("TOPLEFT", c_x, -c_y)
	MG.Options.Frame.CB_RAID.text:SetText("myRaid")
	MG.Options.Frame.CB_RAID:SetChecked(false)
	MG.Options.Frame.CB_RAID:SetScript("onClick", function(self) self:SetChecked(true) MG.Options.Frame.CB_RND:SetChecked(false) MG.Options.Frame.TEXT_RND:Disable() MG.Options.Frame.TEXT_RAID:Disable() end)
	c_x = c_x + MG.Options.Frame.CB_RND:GetWidth() + MG.Options.Frame.CB_RND.text:GetWidth() + 10
	MG.Options.Frame.TEXT_RAID = CreateFrame("EditBox", nil, MG.Options.Frame, "InputBoxTemplate")
	MG.Options.Frame.TEXT_RAID:SetPoint("Topleft", c_x, -(c_y+5))
	MG.Options.Frame.TEXT_RAID:SetSize(100, 20)
	MG.Options.Frame.TEXT_RAID:SetText(MG_MyRaidSymbol or "+")
	MG.Options.Frame.TEXT_RAID:Disable()
	MG.Options.Frame.TEXT_RAID:SetScript("onMouseUp", function(self) 
		MG.Options.Frame.TEXT_RND:Disable()
		MG.Options.Frame.TEXT_RND:HighlightText(0,0)
		MG.Options.Frame.CB_RND:SetChecked(false)
		MG.Options.Frame.CB_RAID:SetChecked(true)
		self:Enable() 
		self:HighlightText() end)
	MG.Options.Frame.TEXT_RAID:SetScript("onKeyDown", function(self, key) if(key=="ENTER") then self:Disable() end end)
	
	MG.Options.Frame:SetScript("onHide", function() 
		MG.myRaid = MG.Options.Frame.CB_RAID:GetChecked()
		MG_WhisperText = MG.Options.Frame.TEXT_RND:GetText()
		MG_MyRaidSymbol = MG.Options.Frame.TEXT_RAID:GetText()
	end)
	MG.Options.Frame:Hide()
end

function MG.getTextureByInstanceID(id)
	if (id == 8638) then return 1718203 end
end

MG.initOptions()
MG.getMyEquipment() 
MG.myLootGroup = MG.getLootGroup(UnitName("player"))
MG.base:RegisterEvent("GROUP_ROSTER_UPDATE")
MG.base:RegisterEvent("GROUP_JOINED")
MG.base:RegisterEvent("INSPECT_READY")
MG.base:RegisterEvent("CHAT_MSG_LOOT")
MG.base:RegisterEvent("CHAT_MSG_RAID")
MG.base:RegisterEvent("ADDON_LOADED")
MG.base:RegisterEvent("PLAYER_LOGOUT")
MG.base:SetScript("onEvent", MG.eventhandler)
MG.base:SetScript("onUpdate", MG.inspectPlayers)
MG.initViewport()
MG.initDebugWindow()
MG.Viewport:Hide()
